; Copyright (C) Horstmann Software Design Corp. 1987, 1988. 
; All Rights Reserved.
;
;============================================================================
;
;----------------- EQUATES -----------------------------------
;
EGABLOCK     EQU        23	; blocks in the EGA table
VGABLOCK     EQU        29	; blocks in the VGA table (conjectured)
MAXNBLOCK    EQU        50	; maximum number of blocks that can be moved
PSTRING      EQU   	9H
DOSCALL	     EQU   	21H
EXIT         EQU   	4CH
CR           EQU   	0DH
LF           EQU   	0AH
;
;============================================================================
;
CODESEG SEGMENT PARA PUBLIC
	ASSUME   CS:CODESEG
;
	JMP  START
;
SAVE_PTR DD	7 DUP (?)    	; Pointer parameter area
PARAM_AREA DB   MAXNBLOCK*64 DUP (?)  ; 
NBLOCK	DB 	? 		; # of blocks to be moved
;
;--------------------------------------------------------------------------
;
usagemesg db   	'Copyright (C) Horstmann Software Design Corp. 1987, 1988.',cr,lf
	db 	'All Rights Reserved',cr,lf
	db	'Syntax: VEGAINIT  n | -E | -V',cr,lf
	db	'$'
;-------------------------------------------------------------------------
;
START: 
; read the number of blocks (or -E or -V) from the
; command line. Give an error message if not ok
;
;Establish the Board (EGA OR VGA)
;
	call	getarg
	mov	cs:nblock,al
;
	 CLD  
	 XOR 	AX,AX 
	 MOV 	ES,AX 
	 LDS 	SI,ES:04A8H       ;save_ptr at location 0000:04a8h
				  ;It points to 7 other double-words
	 MOV 	DI,OFFSET SAVE_PTR 
	 MOV 	ES:04A8H,DI 
	 MOV 	ES:04AAH,CS       
	 PUSH	CS 
	 POP 	ES 
	 MOV 	CX,14		; move 7 pointers = 14 words
	 REPZ 	MOVSW  
	 LDS 	SI,ES:SAVE_PTR
	 MOV 	DI,OFFSET PARAM_AREA
	 MOV 	WORD PTR ES:SAVE_PTR, DI 
	 MOV 	WORD PTR ES:SAVE_PTR+2,CS  
         MOV 	AL, CS:NBLOCK
	 MOV 	AH, 32
 	 MUL	AH
	 MOV 	CX, AX         	; move 64 * NBLOCK bytes
	 REPZ 	MOVSW  
	 MOV 	DX,OFFSET PARAM_AREA+256	; 256 = PSP size
	 XOR    AX, AX
	 MOV 	AL, CS:NBLOCK
	 MOV 	AH,64
	 MUL 	AH
	 ADD 	DX,AX  	 	; = #of bytes to keep resident
	 INT 	27H      	; Terminate & Stay Resident
;
;------------------------------------------------------------------------
getarg	proc	near
; Receives:  Nothing
; Returns:  AX = number entered on command line or 
;    AX = EGABLOCK  if command line is  -E
;    AX = VGABLOCK  if command line is  -V
;
    	mov   si, 81h		; command line tail in PSP
blank_loop:
     	cmp      byte ptr [si], ' '
     	jne      noblank
     	inc      si
     	jmp      blank_loop
noblank:
	cmp	byte ptr [si],'-'
	je	minus
;
	xor	al,al
digitloop:
	cmp	byte ptr [si],'0'
	jl	nodigit
	cmp	byte ptr [si],'9'
	jg	nodigit
;
	mov	ah,10
	mul	ah
	add	al,[si]
	sub	al,'0'
	inc	si
	jmp	digitloop
nodigit:
	cmp	byte ptr [si],cr
	jne	usage
;
	cmp	al,0
	je	usage
	cmp	al,maxnblock
	ja	usage
	ret
;
minus:
	mov	al,[si+1]
	and	al,0dfh		; convert to cap
	cmp	al,'E'
	je	ega
	cmp	al,'V'
	je	vga
usage:
; Display the usage message and terminate the entire program
 	mov     ax, cs
 	mov     ds, ax
 	lea     dx, usagemesg
 	mov     ah, pstring  
 	int    	doscall   
	mov 	ah, exit
	int	doscall
;
ega:
	mov	al, egablock
	ret
vga:
	mov	al, vgablock
	ret
;
getarg	endp
;
CODESEG ENDS
 END

        
