/****************************************************************************
* COPYRIGHT (C):		1987..89, Horstmann Software Design Corporation
* PROJECT:				Chiwriter
* FILE:					vegatabl.c
* PURPOSE:				VGA/EGA Color Table Remapper
* VERSION				1.2
* LANGUAGE:				MS C 5.1, Large Memory Model
* TARGET:				IBM PC
* PROGRAMMER:			Cay Horstmann (CSH)
* TAB STOPS:			3
* UPDATE HISTORY:		1.1 Added VGA 
*							1.2 Used color names instead of a vector of codes
*
****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char *colors[] = { "Black", "Blue", "Green", "Cyan", "Red", "Purple",
"Brown", "Grey", "LightGrey", "LightBlue", "LightCyan", "LightRed", 
"LightPurple", "Yellow", "White" };

void usage( void )
{	int i;

	fprintf(stderr,"Usage: VEGATABL mode color:code color:code...\n");
	fprintf(stderr,"The code is an octal number (rgbRGB)\n");
	fprintf(stderr,"Legal color names are:\n");
	for( i = 0; i < sizeof( colors ) / sizeof( char *); i++ )
		fprintf(stderr, "     %s\n", colors[ i ] );
	exit( 1 );
}

int main( int argc, char *argv[] )
{ 	int i, j, offset, color;
	unsigned char *p, *a;
	unsigned char **q;
	unsigned char ***r;

	printf("VGA/EGA color table remapper. (C) Horstmann Software Design Corp. 1988..89\n");

	if( argc < 3 ) usage();
	offset = atoi( argv[1] );
	r = (unsigned char ***) 0x000004A8L; /* SAVE_PTR */
	q = *r;          /* DWORD_1 */
	p = *q + 35 + 64 * offset;
	for( j = 2; j < argc; j++ )
	{	if( a = strchr( argv[ j ], ':' ) )
		for( i = 0; i < 16 && strnicmp( argv[ j ], colors[ i ], a - argv[j] ); i++ )
			;
		if( i < 16 )
		{	sscanf( a+1, "%o", &color );
			p[i]  = (unsigned char) color;
		}
		else usage();
	}
	return( 0 );
}
